local helpers = require("Helpers")
local tracker = require("Tracker")
local device = require("Device")
local divine = require("Divine")
local spark = require("Spark")
local dark1616m = require("Dark1616M")
local dark8mai = require("Dark8Mai")

local m =
{
}


function m.GetFields()
	local fields =
	{
	}

	return fields
end


function m.Parse(proto, buffer, ip, tree)
	local size = buffer:len()

	-- The packet may contain multiple commands
	
	while size > 0 do
		if size < 4 then
			helpers.ErrorSize(subTree)
			return
		end
		
		-- NOTE: Apparently Fields can't be reused in a loop, so we don't use them here
		local cmd = buffer(0, 1):uint()
		
		if cmd == 0 then
			tree:append_text("INVALID")
			return
		end
		
		local subtree
		local bytes
		local consumed = 0
		local isProcessed = false

		if cmd < 128 then -- 4-bytes command
			consumed = 4
			bytes = buffer(0, consumed)
			subtree = tree:add(proto, bytes, "Command")
			subtree:add(g_f.opcode, buffer(0, 1))

			if cmd <= 4 then
				device.ParseCommand(bytes, subtree)
				isProcessed = true
			end
		elseif cmd < 192 then -- 8-bytes command		
			if size < 8 then
				helpers.ErrorSize(subTree)
				return
			end

			consumed = 8
			bytes = buffer(0, consumed)
			subtree = tree:add(proto, bytes, "Command")
			subtree:add(g_f.opcode, buffer(0, 1))
			
			if cmd == 128 then
				device.ParseCommand(bytes, subtree)
				isProcessed = true
			end
		else -- variable length command
			consumed = buffer(2, 2):le_uint() * 4 + 4
			
			if size < consumed then
				helpers.ErrorSize(subTree)
				return
			end

			bytes = buffer(0, consumed)
			subtree = tree:add(proto, bytes, "Command")
			subtree:add(g_f.opcode, buffer(0, 1))

			if cmd == 192 then
				device.ParseCommand(bytes, subtree)
				isProcessed = true
			end
		end

		if not isProcessed then
			local pid = tracker.GetPid(ip)
			
			if pid == 6 then
				dark1616m.ParseCommand(bytes, subtree)
			elseif pid == 28 then
				dark8mai.ParseCommand(bytes, subtree)
			elseif pid == 30 then
				spark.ParseCommand(bytes, subtree)
			elseif pid == 49 then
				divine.ParseCommand(bytes, subtree)
			else
				subtree:append_text(" (PID unknown)")
			end
		end

		if consumed < buffer:len() then
			buffer = buffer(consumed)
			size = buffer:len()
		else
			size = 0
		end
	end
end


return m
