local helpers = require("Helpers")

local m =
{
	statusIP = ProtoField.ipv4("gs.config.statusIP", "Status IP"),
	statusPort = ProtoField.uint16("gs.config.statusPort", "Status port", base.DEC)
}


function m.GetFields()
	local fields =
	{
		config_statusPort = m.statusPort,
		config_statusIP = m.statusIP
	}
	
	return fields
end


function m.Parse(proto, buffer, tree)
	tree = tree:add(proto, buffer(), "Config")
	
	local size = buffer:len()

	if size ~= 8 then
		helpers.ErrorSize(tree)
		return
	end
	
	tree:add(m.statusIP, buffer(0,4))
	tree:add(m.statusPort, buffer(4,2))
end

return m
