g_f =
{
	flags8 = ProtoField.uint8("gs.f_flags8", "Flags", base.HEX),
	flags16 = ProtoField.uint16("gs.f_flags16", "Flags", base.HEX),
	flags32 = ProtoField.uint32("gs.f_flags32", "Flags", base.HEX),
	size8 = ProtoField.uint8("gs.f_size8", "Size", base.DEC),
	size16 = ProtoField.uint16("gs.f_size16", "Size", base.DEC),
	length8 = ProtoField.uint8("gs.f_length8", "Length in words", base.DEC),
	length16 = ProtoField.uint16("gs.f_length16", "Length in words", base.DEC),
	type8 = ProtoField.uint8("gs.f_type8", "Type", base.DEC),
	opcode = ProtoField.uint8("gs.f_opcode", "Opcode", base.DEC),
	generation = ProtoField.uint8("gs.f_generation", "Generation", base.DEC),
	meters = ProtoField.bytes("gs.f_meters", "Meters"),
	gains = ProtoField.bytes("gs.f_gains", "Gains"),
	gain = ProtoField.uint8("gs.f_gain", "Gain", base.DEC),
	volume = ProtoField.uint8("gs.f_volume", "Volume", base.DEC),
	pan = ProtoField.int8("gs.f_pan", "Pan", base.DEC),
	temperature = ProtoField.uint8("gs.f_temperature", "Temperature", base.HEX),
	enable = ProtoField.uint8("gs.f_enable", "Enable", base.DEC),
	channel = ProtoField.uint8("gs.f_channel", "Channel", base.DEC),
	chPair = ProtoField.uint8("gs.f_chPair", "Ch. pair", base.DEC),
	button = ProtoField.uint8("gs.f_button", "Button", base.DEC),
	delay = ProtoField.uint8("gs.f_delay", "Delay", base.DEC),
	filter = ProtoField.uint8("gs.f_filter", "Filter", base.DEC),
	state = ProtoField.uint8("gs.f_state", "State", base.DEC),
	mode = ProtoField.uint8("gs.f_mode", "Mode", base.DEC),
	choice = ProtoField.uint8("gs.f_choice", "Choice", base.DEC),
	pairing = ProtoField.uint8("gs.f_pairing", "Pairing", base.DEC),
}


function g_f.GetFields()
	local fields =
	{
		flags8 = g_f.flags8,
		flags16 = g_f.flags16,
		flags32 = g_f.flags32,
		size8 = g_f.size8,
		size16 = g_f.size16,
		length8 = g_f.length8,
		length16 = g_f.length16,
		type8 = g_f.type8,
		opcode = g_f.opcode,
		generation = g_f.generation,
		meters = g_f.meters,
		gains = g_f.gains,
		gain = g_f.gain,
		volume = g_f.volume,
		pan = g_f.pan,
		temperature = g_f.temperature,
		enable = g_f.enable,
		channel = g_f.channel,
		chPair = g_f.chPair,
		button = g_f.button,
		delay = g_f.delay,
		filter = g_f.filter,
		state = g_f.state,
		mode = g_f.mode,
		choice = g_f.choice,
		pairing = g_f.pairing,
	}
	
	return fields
end


function g_f.EnableName(val)
	if val == 0 then return "Disabled"
	elseif val == 1 then return "Enabled"
	end

	return "Invalid"
end


function g_f.OffOnName(val)
	if val == 0 then return "Off"
	elseif val == 1 then return "On"
	end

	return "Invalid"
end


function g_f.ButtonModeName(val)
	if val == 0 then return "Intelligent"
	elseif val == 1 then return "Momentary"
	elseif val == 2 then return "Toggling"
	elseif val == 3 then return "Cough"
	elseif val == 4 then return "AlwaysOn"
	elseif val == 5 then return "AlwaysOff"
	end

	return "Invalid"
end


function g_f.PotModeName(val)
	if val == 0 then return "Unlimited"
	elseif val == 1 then return "Limited"
	end
	
	return "Invalid"
end


function g_f.AnalogueInputModeName(val)
	if val == 0 then return "Reserved"
	elseif val == 1 then return "Line"
	elseif val == 2 then return "Mic"
	elseif val == 3 then return "Mic+Phantom"
	end
	
	return "Invalid"
end


function g_f.PairingName(val)
	if val == 0 then return "Mono"
	elseif val == 1 then return "Stereo"
	end
	
	return "Invalid"
end


function g_f.LockName(val)
	if val == 0 then return "Unlocked"
	elseif val == 1 then return "Locked"
	end
	
	return "Invalid"
end


function g_f.ADName(val)
	if val == 0 then return "Analogue"
	elseif val == 1 then return "Digital"
	end
	
	return "Invalid"
end


function g_f.ToCelsius(val)
	return 0.5 * val + 44.0
end


function g_f.ToVolumePan(range)
	return " (Vol="..range(0, 1):uint()..", Pan="..range(1, 1):int()..")"
end

return g_f
