local m =
{
	errSize = ProtoExpert.new("gs.errSize.expert", "Invalid message size", expert.group.MALFORMED, expert.severity.ERROR),
	warnSize = ProtoExpert.new("gs.warnSize.expert", "Invalid message size", expert.group.MALFORMED, expert.severity.WARN)
}

-- Made by Doug Currie (https://stackoverflow.com/users/33252/doug-currie)
-- on Stack Overflow. https://stackoverflow.com/questions/1283388/lua-merge-tables
function m.merge_tables(from, to)
    for k,v in pairs(from) do to[k] = v end
end


function m.GetExperts()
	local experts =
	{
		errSize = m.errSize,
		warnSize = m.warnSize
	}
	
	return experts
end


function m.ErrorSize(tree)
	tree:add_proto_expert_info(m.errSize)
end


function m.WarnSize(tree)
	tree:add_proto_expert_info(m.warnSize)
end

return m
