local helpers = require("Helpers")
local tracker = require("Tracker")
local device = require("Device")
local divine = require("Divine")
local spark = require("Spark")
local dark1616m = require("Dark1616M")
local dark8mai = require("Dark8Mai")

local m =
{
}


function m.GetFields()
	local fields =
	{
	}
	
	return fields
end


function m.Parse(proto, buffer, ip, tree)
	tree = tree:add(proto, buffer(), "Status")
	local size = buffer:len()
	
	if size < 8 then
		helpers.ErrorSize(tree)
		return
	end
	
	device.ParseStatus(proto, buffer, tree)

	local pid = tracker.GetPid(ip)
	buffer = buffer(8)
	
	if pid == 0 then
		tree:append_text(" (PID unknown)")
		
		if dark1616m.MaybeValidStatus(buffer) then pid = 6
		elseif dark8mai.MaybeValidStatus(buffer) then pid = 28
		elseif spark.MaybeValidStatus(buffer) then pid = 30
		elseif divine.MaybeValidStatus(buffer) then pid = 49
		end
	end
	
	tree:append_text(" ("..tracker.GetDeviceName(pid)..")")
	
	if pid == 6 then
		dark1616m.ParseStatus(buffer, tree)
	elseif pid == 28 then
		dark8mai.ParseStatus(buffer, tree)
	elseif pid == 30 then
		spark.ParseStatus(buffer, tree)
	elseif pid == 49 then
		divine.ParseStatus(buffer, tree)
	end
end

return m
